// Nicovideo NewPlayer Controller v1.2
// 以下元ネタ
// Nicocacheスレ6の>>323>>>333氏
// @name		Nicovideo Controller
// @author		azu
// @namespace		http://web.zgo.jp/
// @include		http://www.nicovideo.jp/watch/*
// ==/UserScript==
// 元ネタ @author	dionore
// ニコニコをキーボード操作するGreasemonkeyスクリプト - てｓｔ [ http://d.hatena.ne.jp/dionore/20081213/1229175974 ]

(function() {
	//自動再生の有無(trueで自動再生，falseで再生しない)
	var AUTO_PLAY = false;
	//自動で最大化するか(trueで自動最大化、falseで最大化しない)
	var AUTO_PLAY_MAX = false;

	//自動移動の有無(trueで自動移動，falseで移動しない)
	var AUTO_SCROLL = false;
	//自動移動先。trueならタグ、falseならプレイヤーまで
	var AUTO_SCROLL_TAG = true;

	// 早送り・巻き戻し量(秒)
	var SEEK_FW = 5;
	var SEEK_BK = 5;

	// キーボード操作がデフォで有効かどうか。falseにすればdefaultでoff
	var keySeek=true;

	//プレイヤー上どこででも、ホイールで音量変化（trueで音量変化、falseでシーク）
	var VOL_WHEEL = false;
	// 音量変化量
	var VOL_LEVEL = 10;

	// 最大化時にコントローラ部分を画面外に押し出す
	var useControllerPushOut = false;

	// デフォルトのプレイヤー拡大率(%)
	var PLAYER_SIZE = 100;
	// プレイヤーサイズの変更量(%)
	var SIZE_VAL = 25;

	// ↑↑↑↑↑↑↑↑ 設定ここまで ↑↑↑↑↑↑↑↑

	// プレイヤーのデフォルトのモード。基本自動判定する
	// [0:新プレイヤー、1:新新プレイヤー(4:3)、2:新新プレイヤー(16:9) ]
	// これに合わせて、ホイールでボリュームの位置調節と新プレのキーボードバグの対処
	var playerMode = 1;
	try {
		if (npc_usingPlayer != undefined) {
			playerMode = npc_usingPlayer;
		}
	} catch (e) {}

	var PLAYER_DEF_WIDTH;
	var PLAYER_DEF_HEIGHT;

	var PLAYER_CONT_VOL_X0;
	var PLAYER_CONT_VOL_X1;
	var PLAYER_CONT_VOL_Y0;
	var PLAYER_CONT_VOL_Y1;

	if (playerMode == 0) {
// 新プレイヤー用ボリューム位置
		PLAYER_CONT_VOL_X0 = 389;
		PLAYER_CONT_VOL_X1 = 445;
		PLAYER_CONT_VOL_Y0 = 458;
		PLAYER_CONT_VOL_Y1 = 480;
	} else if (playerMode == 1) {
// 新新プレイヤー(4:3)用ボリューム位置
		PLAYER_CONT_VOL_X0 = 380;
		PLAYER_CONT_VOL_X1 = 450;
		PLAYER_CONT_VOL_Y0 = 450;
		PLAYER_CONT_VOL_Y1 = 473;
	} else {
// 新新プレイヤー(16:9)用ボリューム位置
		PLAYER_CONT_VOL_X0 = 510;
		PLAYER_CONT_VOL_X1 = 580;
		PLAYER_CONT_VOL_Y0 = 450;
		PLAYER_CONT_VOL_Y1 = 473;
	}

	var playerMaxiWidth=690;
	var playerMaxiHeight=384;

	var TIME = "";
	var FLVPLAYER = null;
	var onFlvplayer = false;
	// watch.jsのfunctionを上書きする
	var captureResizeFunction;
	var captureFitFunction;
	var baseColor="#ffffff";
	function toggleMaximizePlayer_new() {
		FLVPLAYER.style.height="100%";
		document.body.style.overflow.overflowX="visible";
		captureResizeFunction();
		resizePlayer(PLAYER_SIZE);
		Element.scrollTo(FLVPLAYER);
		setClickEvent();
	}
	function setClickEvent() {
		if (playerMaximized) {
			baseColor=document.body.style.background;
			document.body.style.background="#000000";
		    Event.observe(document, 'click', clickPause);
//		    Event.observe(document, 'dblclick', clickPause);
		} else {
			document.body.style.background=baseColor;
		    Event.stopObserving(document, 'click', clickPause);
//		    Event.stopObserving(document, 'dblclick', clickPause);
		}
	}
	function clickPause(e) {
		Event.stop(e);
		play_pause();
	}
	function fitPlayerToWindow_new() {
		var swf=$('flvplayer');
		var swfc=$('flvplayer_container');
		var width = window.innerWidth || document.documentElement.clientWidth;
		var height = window.innerHeight || document.documentElement.clientHeight;
		var p_width,p_height,p_margin;
		if (useControllerPushOut) {
// FXで画面外に押し出すと、水平スクロールバーが出てしまう
			document.body.style.overflow.overflowX="hidden";
			var fitHeight = (width/playerMaxiWidth)*playerMaxiHeight;
			if (fitHeight > height) {
				p_height=(height>playerMaxiHeight) ? height+50 : playerMaxiHeight+50;
				p_width=Math.floor((p_height/playerMaxiHeight)*playerMaxiWidth);
				p_margin=Math.floor((width-p_width)/2);
			} else {
				p_width=(width>playerMaxiWidth) ? width : playerMaxiWidth;
				p_height=Math.floor((p_width/playerMaxiWidth)*playerMaxiHeight)+50;
				p_margin=0;
			}
			swf.style.width=p_width+"px";
			swfc.style.height=p_height+"px";
			swf.style.marginLeft=p_margin+"px";
		} else {
			captureFitFunction();
		}
		try {
			swf.TSetProperty("_root",2,100);
			swf.TSetProperty("_root",3,100);
		} catch (e) {}
	}
	// FXでsetTimeoutやると、引数がundefinedじゃないので対策
	function firstResize() {
		resizePlayer(PLAYER_SIZE);
	}
	function resizePlayer(p) {
		if (playerMaximized || p<=0) return;
		var swf=$('flvplayer');
		var swfc=$('flvplayer_container');
		swf.style.width=swfc.style.width=PLAYER_DEF_WIDTH*p/100+"px";
		swf.style.height=swfc.style.height=PLAYER_DEF_HEIGHT*p/100+"px";
		var left = Math.floor((PLAYER_DEF_WIDTH-PLAYER_DEF_WIDTH*p/100)/2);
		if (left>0) left=0;
		swfc.style.marginLeft=left+"px";
		swf.style.marginLeft="0px";
		try {
			swf.TSetProperty("_root",2,p);
			swf.TSetProperty("_root",3,p);
		} catch (e) {}
		PLAYER_SIZE = p;
	}
// ホイール処理
	function wheel(e) {
		try {
			if (FLVPLAYER.ext_getVideoSize() == "normal") {
				var p = Position.cumulativeOffset(FLVPLAYER);
				var x = -p[0];
				var y = -p[1];
				if(e) {
					x += e.pageX;
					y += e.pageY;
				} else {
					x += event.clientX + (document.body.scrollLeft || document.documentElement.scrollLeft);
					y += event.clientY + (document.body.scrollTop  || document.documentElement.scrollTop);
				}
				if ((x<0 || x>PLAYER_DEF_WIDTH*PLAYER_SIZE/100 || y<0 || y>PLAYER_DEF_HEIGHT*PLAYER_SIZE/100) && (x<PLAYER_CONT_VOL_X0*PLAYER_SIZE/100 || x>PLAYER_CONT_VOL_X1*PLAYER_SIZE/100 || y<PLAYER_CONT_VOL_Y0*PLAYER_SIZE/100 || y>PLAYER_CONT_VOL_Y1*PLAYER_SIZE/100)) return;
			}
		} catch(err) {
			return;
		}

	    var delta = 0;
	    if (!e)
	        e = window.event;
	    if (e.wheelDelta) {
	        /* IE/Opera. */
	        delta = e.wheelDelta / 120;
//	        if (window.opera) delta = -delta;
	    } else if (e.detail) {
	        /** Mozilla case. */
	        delta = -e.detail / 3;
	    }
	    /** If delta is nonzero, handle it.
	    * Basically, delta is now positive if wheel was scrolled up,
	    * and negative, if wheel was scrolled down.
	    */
	    if (delta) {
// VOL_WHEELは互換性の為に残す
			if (x>=PLAYER_CONT_VOL_X0*PLAYER_SIZE/100 && x<=PLAYER_CONT_VOL_X1*PLAYER_SIZE/100 && y>=PLAYER_CONT_VOL_Y0*PLAYER_SIZE/100 && y<=PLAYER_CONT_VOL_Y1*PLAYER_SIZE/100 || VOL_WHEEL) {
			    if (delta < 0)
					volume(-VOL_LEVEL);
				else
					volume(VOL_LEVEL);
			} else {
			    if (delta < 0)
					seek(SEEK_FW);
				else
					seek(-SEEK_BK);
			}
	    }
	    if (e.preventDefault) {
	        e.preventDefault();
	    }
	    e.returnValue = false;
	}
	var keyCode=function(e){
		if(document.all) return e.keyCode;
		else if(document.getElementById) return e.keyCode? e.keyCode:e.charCode;
		else if(document.layers) return e.which;
	};
	function cont_init() {
	    if (!getFlvplayer()) {
			setTimeout(cont_init, 1000);
			return;
		}
		// wrapper(旧プレイヤー)かどうか判断
		var isWrapper = true;
		try {
			var nico = $("flvplayer").GetVariable("o");
			if (nico == null || nico == 'null') throw "";
		} catch(e) {
			isWrapper = false;
		}
		if (isWrapper) return;

/*
		Event.observe(document, 'mousemove', function (e) {
			var str = "";
			var p = Position.cumulativeOffset(FLVPLAYER);
			// FlvPlayerからの相対位置チェック用
			var x = Event.pointerX(e)-p[0];
			var y = Event.pointerY(e)-p[1];
			str = "x;"+x+" y:"+y;
			// プレイヤーステータス表示用
			try {
				str += " "+FLVPLAYER.ext_getVideoSize();
				str += " "+FLVPLAYER.ext_getStatus();
				str += " "+FLVPLAYER.ext_getPlayheadTime();
				str += " "+FLVPLAYER.ext_getTotalTime();
				str += " "+FLVPLAYER.ext_isMute();
				str += " "+FLVPLAYER.ext_isRepeat();
			} catch(err) {}
			document.title  = str;
		});
*/

		PLAYER_DEF_WIDTH = FLVPLAYER.clientWidth;
		PLAYER_DEF_HEIGHT = FLVPLAYER.clientHeight;

		// プレイヤーリサイズ･画面外にコントローラ部分を押し出す･
		// 画面クリック用に関数入れ替え
		captureResizeFunction = toggleMaximizePlayer;
		toggleMaximizePlayer = toggleMaximizePlayer_new;
		captureFitFunction = fitPlayerToWindow;
		fitPlayerToWindow = fitPlayerToWindow_new;

		// keypressイベント
	    Event.observe(document, 'keypress', function (e) {
//			↓keyCode確認用 playerの右上にcode番号が表示されます。設定を変更する場合に使用して下さい。
//			balloon("flvplayer","keyPress:"+keyCode(e),"lT");
			if (Event.element(e).type == "text" ) return;
			if(keySeek){
				if(e.shiftKey || e.ctrlKey || e.altKey) return;
				switch(keyCode(e)){
					case 37:seek(-SEEK_BK); break; // left(seek down)
					case 38:volume(VOL_LEVEL); break; // up(volume up)
					case 39:seek(SEEK_FW); break; // right(seek up)
					case 40:volume(-VOL_LEVEL); break; // down(volume down)
					default:return;
				}
				Event.stop(e);
			}
	    });
		// keydownイベント
	    Event.observe(document, 'keydown', function (e) {
	        var key = keyCode(e);
			// "keypress"と"keydown"ではcode番号が異なるので注意して下さい。
//			balloon("flvplayer","keyCode:"+key,"lT");
			if (Event.element(e).type == "text") return;
			if(keySeek){
				if(e.ctrlKey || e.altKey) return;
		        if (key >= 48 && key <= 57) // 数字(メインキー)
					TIME += key - 48 + "";
		        else if (key >= 96 && key <= 105) // 数字(テンキー)
					TIME += key - 96 + "";
				else if(key == 110 || key ==190 || key == 186 || key == 189) // ".-:"(テンキー含む)
					TIME += ".";
				var tc=FLVPLAYER.ext_getTotalTime()/10|0;
				switch(key){
					case 32:play_pause(); break; // space(再生/停止)
					// ↓shift+left(現在の再生時間から再生可能時間の10分の1をseek down) この値は上のtc=で変更できます。
					case 37:if(e.shiftKey) seek(-tc);
							break;
					// ↓shift+right(現在の再生時間から再生可能時間の10分の1をseek up)
					case 39:if(e.shiftKey) seek(tc);
							break;
					// ↓shift+up(volume Max)
					case 38:if(e.shiftKey) volume(100);
							break;
					// ↓shift+down(volume Min)
					case 40:if(e.shiftKey) volume(-100);
							break;
					case 8: case 44: case 188:FLVPLAYER.ext_setPlayheadTime(0); break; // backspace or ","(カンマ)(動画の頭に移動)
//					case 46: case 190:FLVPLAYER.ext_setPlayheadTime(FLVPLAYER.ext_getTotalTime()); break; // del or "."(ピリオド)(動画の最後に移動)
					case 72:comment(); break; // h(コメント)
					case 77:mute(); break; // m(ミュート)
					case 82:repeat(); break; // r(リピート)
					case 84:time(); break; // r(リピート)
					case 13:fullscreen(); break; // enter(フルスクリーン)
					case 113: // F2(キーボードシーク on/off) 変更する場合は下のelseも変更して下さい。
						keySeek=false;
						balloon("flvplayer","keyboard seek:off","lT");
						break;
					case 70: // f(フルスクリーンモード切替)
						if (playerMaximized) {
							useControllerPushOut=!useControllerPushOut;
							fitPlayerToWindow_new();
						}
						break;
					case 107:case 81: // num+,q(size up)
						resizePlayer(PLAYER_SIZE+SIZE_VAL); break;
					case 109:case 65: // num-,a(size down)
						resizePlayer(PLAYER_SIZE-SIZE_VAL); break;
					default:return;
				}
				Event.stop(e);
			}
			else if(key==113){
				keySeek=true;
				balloon("flvplayer","keyboard seek:on","lT");
			}
	    });
		// prototype.jsに無いイベント
		if (window.addEventListener){
			// Chromeとかうまく判別できないから、強引に2つイベントを登録する
			// 今の所対応してない方はエラーにもならないから放置
	    	window.addEventListener('mousewheel', wheel, false);
	    	/** DOMMouseScroll is for mozilla. */
	    	window.addEventListener('DOMMouseScroll', wheel, false);
	    } else {
		    /** IE **/
			window.onmousewheel = document.onmousewheel = wheel;
		}
		// フラッシュからフォーカスをはずす
		FLVPLAYER.blur();
		window.focus();

		autoScroll();
	    autoPlay();
		setTimeout(firstResize, 100); //chrome用にウェイトかます
	}
	
	cont_init();
	
	// ----プレイヤー操作関数----
	function autoScroll() {
	    if (!getFlvplayer()) return;
	    if (AUTO_SCROLL && !AUTO_SCROLL_TAG)
			Element.scrollTo(FLVPLAYER);
	    if (AUTO_SCROLL && AUTO_SCROLL_TAG) {
			var tmp = Position.cumulativeOffset($('video_tags'));
			window.scrollTo(0, tmp[1]-16);
		}
	}
	function autoPlay() {
	    if (!getFlvplayer()) return;
		var stime;
		try {
			stime = FLVPLAYER.ext_getPlayheadTime();
		} catch(e) {
			setTimeout(autoPlay, 1500);
		}
		if (stime == 0) setTimeout(function () {
			if (AUTO_PLAY_MAX)
				FLVPLAYER.ext_setVideoSize("fit");
			if (AUTO_PLAY && FLVPLAYER.ext_getPlayheadTime() == 0)
				play_pause();
		}, 1500);
	}
	var playStatus = true;
	var playFirst = true;
	function play_pause() {
	    if (!getFlvplayer()) return;
	    var status = FLVPLAYER.ext_getStatus();
		if (playFirst && FLVPLAYER.ext_getPlayheadTime() == 0)
			status = "paused";
		playFirst = false;
		if (status == "end") status = (playStatus) ? "playing" : "paused";

// 新プレでキーボード一時停止がおかしいバグへの対処
		if (playerMode == 0 && status == "playing") status = (playStatus) ? "playing" : "paused";

	    if (status == "paused" || status == "stopped") {
			FLVPLAYER.ext_play(1);
			playStatus = true;
		} else if (status == "playing") {
			FLVPLAYER.ext_play(0);
			playStatus = false;
		}
	}
	function volume(diff) {
	    if (!getFlvplayer()) return;
	    FLVPLAYER.ext_setVolume(getVol(FLVPLAYER.ext_getVolume() + diff));
	}
	function getVol(v) {
	    if (v > 100) return 100;
	    else if (v < 0) return 0;
	    else return v;
	}
	var forceTarget,forceDiff,forceCount=0;
	function seek(diff) {
	    if (!getFlvplayer()) return;
		if (forceCount > 0) {
			forceTarget += diff;
			return;
		}
		var targetPos = getSeek(FLVPLAYER.ext_getPlayheadTime() + diff, FLVPLAYER.ext_getTotalTime());
		FLVPLAYER.ext_setPlayheadTime(targetPos);
		forceTarget = targetPos;
		forceDiff = diff;
		forceCount = 1;
		setTimeout(forceSeek, 100);
	}
	function forceSeek() {
		var playPos = FLVPLAYER.ext_getPlayheadTime();
		if (((forceDiff > 0 && (forceTarget - playPos) > forceDiff/2.0) ||
			(forceDiff < 0 && (playPos - forceTarget) > -forceDiff/2.0)) &&
			forceCount++ < 10) {
			var newPos = getSeek(forceTarget-0+forceDiff*forceCount, FLVPLAYER.ext_getTotalTime());
			FLVPLAYER.ext_setPlayheadTime(newPos);
			setTimeout(forceSeek, 100);
		} else {
			forceCount = 0;
		}
	}
	function getSeek(cur, total) {
	    if (cur > total)
			return total;
	    else if (cur < 0)
			return 0;
	    else
			return cur;
	}
	function fullscreen() {
	    if (!getFlvplayer()) return;
	    if (FLVPLAYER.ext_getVideoSize() == "fit" || FLVPLAYER.ext_getVideoSize() =="full") {
	        FLVPLAYER.ext_setVideoSize("normal");
	        autoScroll();
	    } else if (FLVPLAYER.ext_getVideoSize() == "normal") {
	        FLVPLAYER.ext_setVideoSize("fit");
	    }
	}
	function repeat() {
	    if (!getFlvplayer()) return;
	    if (FLVPLAYER.ext_isRepeat() == true)
			FLVPLAYER.ext_setRepeat(false);
	    else if (FLVPLAYER.ext_isRepeat() == false)
			FLVPLAYER.ext_setRepeat(true);
	}
	function comment() {
	    if (!getFlvplayer()) return;
	    if (FLVPLAYER.ext_isCommentVisible() == true)
			FLVPLAYER.ext_setCommentVisible(false);
	    else if (FLVPLAYER.ext_isCommentVisible() == false)
			FLVPLAYER.ext_setCommentVisible(true);
	}
	function mute() {
	    if (!getFlvplayer()) return;
	    if (FLVPLAYER.ext_isMute() == true)
			FLVPLAYER.ext_setMute(false);
	    else if (FLVPLAYER.ext_isMute() == false)
			FLVPLAYER.ext_setMute(true);
	}
	function time() {
	    if (!getFlvplayer()) return;
	    TIME = "";
	    var temp = "";
	    setTimeout(function move() {
	        if (TIME == "") {
	            return;
	        } else if (TIME != temp) {
	            temp = TIME;
	            setTimeout(move, 700);
	        } else {
	            FLVPLAYER.ext_setPlayheadTime(getSeek(Math.floor(TIME - 0) * 60 + ((TIME - Math.floor(TIME)) * 100), FLVPLAYER.ext_getTotalTime()));
	        }
	    }, 700);
	}
	function getFlvplayer() {
	    if (!FLVPLAYER) {
	        if ($('flvplayer')) {
	            FLVPLAYER = $('flvplayer');
	        } else {
	            return false;
	        }
	    }
	    return true;
	}
})()
